<template>
  <ob-form
    v-if="formData"
    :form-data="formData"
    :form-model="formModel"
    class="add-subscription"
    @close="$emit('close')"
    @submit="saveSubscription"
  >
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">Укажите название подписки</p>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Наименование подписки"
          v-model="formData.title"
          placeholder="Подписка по умолчанию"
          required
        />
      </div>
    </div>

    <subscription-modal-locations
      :fromLocations="fromLocations"
      :toLocations="toLocations"
      :type="subscriptionType"
      @setType="setType"
      @setLocations="setLocations"
    />
    <subscription-modal-period
      :activeFromDate="formData.activeFromDate"
      :activeToDate="formData.activeToDate"
      :isActiveToDateValid="isActiveToDateValid"
      @setDate="setDate"
    />
    <subscription-modal-clients
      :clientUuids="clients"
      :isAll="clientsIsAll"
      @setClients="setClients"
    />
    <subscription-modal-services
      ref="services"
      :serviceList="formData.services"
      @setServices="setServices"
    />

  </ob-form>
</template>

<script>
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObInput from "common-components/src/obComponents/obInput";
  import dropdownEvents from '@/mixins/dictionaries/dropdown-events';
  import SubscriptionModalLocations from './SubscriptionModalLocations';
  import SubscriptionModalPeriod from './SubscriptionModalPeriod';
  import SubscriptionModalClients from './SubscriptionModalClients';
  import SubscriptionModalServices from './SubscriptionModalServices';
  import { required, requiredIf } from 'vuelidate/lib/validators'
  import { uuid } from "vue-uuid";
  import moment from 'moment';

  const isActiveToDateValid = (value, formData) => {
    const { activeToDate, activeFromDate } = formData;

    if (activeToDate && activeFromDate) {
      return moment(activeFromDate).isBefore(activeToDate)
    }

    return false;
  };

  export default {
    name: 'addSubscription',
    components: {
      ObForm,
      ObInput,
      SubscriptionModalLocations,
      SubscriptionModalPeriod,
      SubscriptionModalClients,
      SubscriptionModalServices
    },
    mixins: [FormValidationMixin, dropdownEvents],
    props: {
      isNew: {
        type: Boolean,
        default: true
      },
      subscription: {
        type: Object,
        required: true,
      },
    },
    data() {
      return {
        formData: null
      }
    },
    mounted() {
      if (!Object.keys(this.subscription).length) {
        this.formData = {
          uuid: uuid.v4(),
          title: '',
          type: 'SHIPMENT_POINTS',
          fromLocations: {
            isAll: false,
            fromLocationUuids: []
          },
          toLocations: {
            isAll: false,
            toLocationUuids: []
          },
          clients: {
            isAll: true,
            clientUuids: []
          },
          services: [{
            serviceTypeUuid: "56eaa734-ad65-47e2-b961-80797818e935",
            isAll: true,
            resourceSubtypeUuids: [],
            serviceUuids: []
          },
          {
            serviceTypeUuid: "5e08d698-e12c-411d-a6ec-7e5ae74877b5",
            isAll: true,
            resourceSubtypeUuids: [],
            serviceUuids: []
          }],
          activeFromDate: new Date(),
          activeToDate: null
        }
      } else {
        this.formData = this.subscription
      }
    },
    computed: {
      formModel () {
        const _self = this

        const defaultData = {
          activeFromDate: {
            value: null
          },
          activeToDate: {
            value: null
            // validator: {
            //   isActiveToDateValid: {
            //     method: isActiveToDateValid,
            //     error: 'Дата окончания периода должна быть после даты начала периода'
            //   }
            // }
          },
          clients: {
            value: {},
            nested_fields: {
              clientUuids: {
                value: [],
              },
              isAll: {
                type: 'boolean',
                value: true
              }
            }
          },
          fromLocations: {
            value: {},
            nested_fields: {
              fromLocationUuids: {
                value: [],
                required: true
              },
              isAll: {
                type: 'boolean',
                value: true
              }
            }
          },
          services: {
            value: []
          },
          title: {
            value: '',
            validator: {
              required
            }
          },
          toLocations: {
            value: {},
            nested_fields: {
              toLocationUuids: {
                value: [],
                validator: {
                  required: requiredIf(function () {
                    return Boolean(_self.subscription.type === 'FROM_TO_BACKWARD')
                  })
                }
              },
              isAll: {
                type: 'boolean',
                value: true
              }
            }
          },
          type: {
            value: 'SHIPMENT_POINTS'
          },
          uuid: {},
        };
        console.log('bbbb', _self.subscription);
        return defaultData
      },
      fromLocations() {
        return this.formData?.fromLocations || {}
      },
      toLocations() {
        return this.formData?.toLocations || {}
      },
      clients() {
        if (!this.formData.clients?.clientUuids) return []

        return this.formData.clients?.clientUuids
      },
      clientsIsAll() {
        return Boolean(this.formData?.clients?.isAll)
      },
      performerUuid() {
        return document.location.pathname.split('/').pop()
      },
      subscriptionType() {
        if (!this.formData?.type) return ''

        return this.formData.type
      },
      isActiveToDateValid() {
        return isActiveToDateValid(true, this.formData)
      },
    },
    watch: {
      'formModel' (ada) {
        console.log('1111', ada);
      }
    },
    methods: {

      saveSubscription () {
        if (!this.isNew) {
          if (this.formData.fromLocations.isAll && this.formData.fromLocations.fromLocationUuids.length) {
            this.formData.fromLocations.fromLocationUuids = []
          }
          if (this.formData.toLocations.isAll && this.formData.toLocations.toLocationUuids.length) {
            this.formData.toLocations.toLocationUuids = []
          }
          let filterServices = [];
          this.subscription.services.forEach((key) => {
            if (key.resourceSubtypeUuids.length) {
              filterServices.push(key)
            }
          });
        } else {
          this.formData.uuid = uuid.v4()
          this.formData.activeFromDate = new Date()

        }

        this.$emit('sendData', this.formData);
      },
      setLocations (locationUuids, direction, isAll) {
        this.formData[`${direction}Locations`].isAll = isAll
        this.formData[`${direction}Locations`][`${direction}LocationUuids`] = []
        this.formData[`${direction}Locations`][`${direction}LocationUuids`].push(...locationUuids)
      },
      setDate (date, diretion) {
        this.formData[diretion] = date;
      },
      setClients({ clientUuids, isAll }) {
        this.formData.clients.clientUuids = clientUuids
        this.formData.clients.isAll = isAll
      },
      setServices(services) {
        this.formData.services = services
      },
      setType(type) {
        this.formData.type = type
      },
    }
  };
</script>

<style lang="scss">
  .add-subscription {
    &-title {
      font-weight: bold !important;
      font-size: 18px !important;
      line-height: 28px !important;
      letter-spacing: 0.4px !important;
      color: #191E32 !important;
      margin-top: 10px !important;
    }
    .row {
      margin: 5px 0;
    }
  }
</style>

